// 2. lekce: Zakladni algoritmus hry

// Prilinkovani knihoven
#include <stdio.h>
#include "allegro.h"


// Deklarace rychlosti hry
#define GAME_SPEED 	      50


// Deklarace globalnich promennych
volatile int game_time;


// Citac
void game_timer()
{
    game_time++;
}
END_OF_FUNCTION(game_timer);

// propocitej nove pozice objektu ve hre
void MoveAll()
{

}

// vykresli vse na obrazovku
void DrawAll()
{

}

// Potrebujeme inicializovat allegro a nahrat nase data
int InitAll()
{
    if ( allegro_init() != 0 ) {
  		  fprintf(stderr, "Allegra se nepodarilo inicializovat.\n");
		    exit(1);
    }

    // Nainstalujeme casovac
    install_timer();
    install_keyboard();

    set_color_depth( 16 );
    if ( set_gfx_mode( GFX_AUTODETECT_WINDOWED, 640, 480, 0, 0 ) != 0 ) {
            set_gfx_mode( GFX_TEXT, 0, 0, 0, 0 );
            allegro_message( "Pozadovany graficky mod neni dostupny!\n %s\n" , allegro_error );
            return(-1);
    }

    // uzamkneme citac a jeho promennou
    LOCK_FUNCTION(game_timer);
    LOCK_VARIABLE(game_time);

    // nastavime citac na preruseni od casovace v nasem PC
    install_int (game_timer, GAME_SPEED);

    return 0;
}

// pred ukoncenim hry musime uvolnit nase data z pameti
void DeleteAll()
{
	   allegro_exit();
}


// main funkce
int main()
{
    if ( InitAll() < 0 ) return -1;

    // vynulovani promenne
    game_time = 0;
    clear_keybuf ();

    // stiskni F10 pro ukonceni hry
    do {
        while (game_time > 0) {

            MoveAll();
            game_time--;
        }
        DrawAll();
    } while (!key[KEY_F10]);

    DeleteAll();

    return 0;
}
END_OF_MAIN();
